/*
    T5.c
    Generated by Gene-Auto toolset ver 2.4.9
    (launcher GALauncherSCICOS)
    Generated on: 15/06/2012 14:17:49.235
    source model: T5
    model version: 6.3
    last saved by:
    last saved on:
*/

/* Includes */

#include "T5.h"

/* Variable definitions */

/*  Output from <SystemBlock: name=T5>/<SystemBlock: name=Counter>/<OutDataPort: name=Counter_6>  */
REAL T5_Counter_Counter_6 = 0.0;
t_Counter_io _Counter_io;
UINT8 i1;
UINT8 index301;
UINT8 index308;

/* Function definitions */

void T5_init(t_T5_state *_state_) {
    /*  START Block: null  */

    Counter_init(_state_);
    /*  END Block: null  */
}

void T5_compute(t_T5_io *_io_, t_T5_state *_state_) {
    /*  Output from -26d26ed8:137ef86bff0:-7f3a/<OutDataPort: name=>  */
    REAL B3;
    /*  Output from -26d26ed8:137ef86bff0:-7f38/<OutDataPort: name=>  */
    REAL B4;
    /*  Output from -26d26ed8:137ef86bff0:-7f2e/<OutDataPort: name=>  */
    REAL B6_2;
    /*  Output from -26d26ed8:137ef86bff0:-7f2e/<OutDataPort: name=>  */
    REAL B6_1;
    /*  Output from -26d26ed8:137ef86bff0:-7f2e/<OutDataPort: name=>  */
    REAL B6_3;
    /*  Output from -26d26ed8:137ef86bff0:-7f29/<OutDataPort: name=>  */
    REAL B7[3];
    /*  Output from -26d26ed8:137ef86bff0:-7f24/<OutDataPort: name=>  */
    REAL B8;
    /*  Output from -26d26ed8:137ef86bff0:-7f21/<OutDataPort: name=>  */
    REAL B9;
    /*  Output from -26d26ed8:137ef86bff0:-7f19/<OutDataPort: name=>  */
    REAL B11;
    /*  Output from -26d26ed8:137ef86bff0:-7f16/<OutDataPort: name=>  */
    REAL B12;
    /*  Output from -26d26ed8:137ef86bff0:-7f04/<OutDataPort: name=>  */
    REAL B16[3];
    /*  Output from -26d26ed8:137ef86bff0:-7f01/<OutDataPort: name=>  */
    REAL B17[3];
    /*  Output from -26d26ed8:137ef86bff0:-7ef9/<OutDataPort: name=>  */
    REAL B19[3];
    /*  Output from -26d26ed8:137ef86bff0:-7ef6/<OutDataPort: name=>  */
    REAL B20[3];
    /*  Output from -26d26ed8:137ef86bff0:-7ef3/<OutDataPort: name=>  */
    REAL B21_2;
    /*  Output from -26d26ed8:137ef86bff0:-7ef3/<OutDataPort: name=>  */
    REAL B21_1;
    /*  Output from -26d26ed8:137ef86bff0:-7ef3/<OutDataPort: name=>  */
    REAL B21_3;
    /*  Output from -26d26ed8:137ef86bff0:-7eb9/<OutDataPort: name=>  */
    REAL Modulo_1;
    /*  Output from -26d26ed8:137ef86bff0:-7eb5/<OutDataPort: name=>  */
    REAL Modulo_2;
    /*  Output from -26d26ed8:137ef86bff0:-7eb3/<OutDataPort: name=>  */
    REAL Modulo_3;
    /*  Output from -26d26ed8:137ef86bff0:-7e83/<OutDataPort: name=>  */
    REAL DIM1_1;
    /*  Output from -26d26ed8:137ef86bff0:-7e81/<OutDataPort: name=>  */
    REAL DIM1_2;
    /*  Output from -26d26ed8:137ef86bff0:-7e7f/<OutDataPort: name=>  */
    REAL DIM1_3;
    /*  START Block: -26d26ed8:137ef86bff0:-7e7f  */
    DIM1_3 = 1.0;
    /*  END Block: -26d26ed8:137ef86bff0:-7e7f  */
    /*  START Block: -26d26ed8:137ef86bff0:-7e81  */
    DIM1_2 = 0.0;
    /*  END Block: -26d26ed8:137ef86bff0:-7e81  */
    /*  START Block: -26d26ed8:137ef86bff0:-7e83  */
    DIM1_1 = -1.0;
    /*  END Block: -26d26ed8:137ef86bff0:-7e83  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f3a  */
    B3 = 3.0;
    /*  END Block: -26d26ed8:137ef86bff0:-7f3a  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eb5  */
    Modulo_2 = 1.0;
    /*  END Block: -26d26ed8:137ef86bff0:-7eb5  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eb9  */
    Modulo_1 = fmod(T5_Counter_Counter_6, B3);
    /*  END Block: -26d26ed8:137ef86bff0:-7eb9  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eb3  */
    Modulo_3 = Modulo_1 + Modulo_2;
    /*  END Block: -26d26ed8:137ef86bff0:-7eb3  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f38  */
    switch((INT8) Modulo_3) {
        case 1:
                        B4 = DIM1_1;
            break;
        case 2:
                        B4 = DIM1_2;
            break;
        case 3:
                        B4 = DIM1_3;
            break;
    }
    /*  END Block: -26d26ed8:137ef86bff0:-7f38  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f29  */
    B7[0] = DIM1_1;
    B7[1] = DIM1_2;
    B7[2] = DIM1_3;
    /*  END Block: -26d26ed8:137ef86bff0:-7f29  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f01  */
    for (i1 = 0; i1 < 3; i1++) {
        B17[i1] = -1.0 * B7[i1];
    }
    /*  END Block: -26d26ed8:137ef86bff0:-7f01  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f21  */
    B9 = -1.0 * B4;
    /*  END Block: -26d26ed8:137ef86bff0:-7f21  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f04  */
    for (i1 = 0; i1 < 3; i1++) {
        B16[i1] = 1.0 * B7[i1];
    }
    /*  END Block: -26d26ed8:137ef86bff0:-7f04  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f24  */
    B8 = 1.0 * B4;
    /*  END Block: -26d26ed8:137ef86bff0:-7f24  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ef6  */
    for (index308 = 0; index308 < 3; index308++) {
        B20[index308] = fabs(B17[index308]);
    }
    /*  END Block: -26d26ed8:137ef86bff0:-7ef6  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ef9  */
    for (index301 = 0; index301 < 3; index301++) {
        B19[index301] = fabs(B16[index301]);
    }
    /*  END Block: -26d26ed8:137ef86bff0:-7ef9  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f16  */
    B12 = fabs(B9);
    /*  END Block: -26d26ed8:137ef86bff0:-7f16  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f19  */
    B11 = fabs(B8);
    /*  END Block: -26d26ed8:137ef86bff0:-7f19  */
    /*  START Block: -26d26ed8:137ef86bff0:-7f2e  */
    B6_2 = B20[0];
    B6_1 = B20[1];
    B6_3 = B20[2];
    /*  END Block: -26d26ed8:137ef86bff0:-7f2e  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ef3  */
    B21_2 = B19[0];
    B21_1 = B19[1];
    B21_3 = B19[2];
    /*  END Block: -26d26ed8:137ef86bff0:-7ef3  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ee6  */
    _io_->B26 = B12;
    /*  END Block: -26d26ed8:137ef86bff0:-7ee6  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ee8  */
    _io_->B25 = B11;
    /*  END Block: -26d26ed8:137ef86bff0:-7ee8  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eee  */
    _io_->B22 = B6_2;
    /*  END Block: -26d26ed8:137ef86bff0:-7eee  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eec  */
    _io_->B23 = B6_1;
    /*  END Block: -26d26ed8:137ef86bff0:-7eec  */
    /*  START Block: -26d26ed8:137ef86bff0:-7eea  */
    _io_->B24 = B6_3;
    /*  END Block: -26d26ed8:137ef86bff0:-7eea  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ee4  */
    _io_->B27 = B21_2;
    /*  END Block: -26d26ed8:137ef86bff0:-7ee4  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ee2  */
    _io_->B28 = B21_1;
    /*  END Block: -26d26ed8:137ef86bff0:-7ee2  */
    /*  START Block: -26d26ed8:137ef86bff0:-7ee0  */
    _io_->B29 = B21_3;
    /*  END Block: -26d26ed8:137ef86bff0:-7ee0  */
}

